package CompileZ;

import java.io.File;
import java.io.FileReader;
import java.util.Scanner;
/** 
 * Transllate the Z opeartors to JAVA code. 
 * @author  Slim KALLEL
 * @version 1.0 20-11-06
 */

public class ParsingZ {
	
	String Name;
	ExtractZInformation Zsp;
	String TabOpeartion[]= new String[100];int nbOp=0;
	
	
	ParsingZ(String N){
		Name=N;
		Zsp = new ExtractZInformation(Name);
	}
	
	/**
	 * 
	 * @param StyleSchema
	 */
	public void getOperationName(String StyleSchema){
		Zsp.StyleSchema(StyleSchema);
		try{
			Scanner s = new Scanner(new FileReader(new File(Name)));
			String line="";
			while(s.hasNext()&& !(line.equals("\\begin{schema}{"+StyleSchema+"}"))) {
		 		line = s.nextLine();
		     }
			line = s.nextLine();
			String OperationName="";
			 while(s.hasNext()){
				 while(s.hasNext()&& !((line.indexOf("\\begin{schema}"))>(-1))){
					 line = s.nextLine();
			     }
				 OperationName=line;
				 boolean contenuPrasing=true;
				 while(s.hasNext()&& (!(line.equals("\\where")))&&(contenuPrasing)) {
					 boolean existsingInt=line.indexOf("?")>(-1);
					 boolean existsingExl=line.indexOf("!")>(-1);
					 boolean existsingChag=line.indexOf("\\Delta")>(-1);
					 boolean existsingNotChag=line.indexOf("\\Xi")>(-1);
					 if((existsingInt || existsingExl || existsingChag|| existsingNotChag)){
						 OperationName=OperationName.substring(15,OperationName.length()-1);
						 TabOpeartion[nbOp]=OperationName;
						 contenuPrasing=false;
						 nbOp++;
					 }
					 line = s.nextLine();
				 }			 	
			 }
			 
		/*	 for(int i=0;i<nbOp;i++){
			 	System.out.println("--->"+TabOpeartion[i]+"<--");
			}*/
		}catch(Exception e){System.out.println("Exception"+e);}
		
	}

	public String getStyleSchemaName(){
		String OperationName="";
		try{
			Scanner s = new Scanner(new FileReader(new File(Name)));
			String line="";
			boolean contenuPrasing=true;
			 while(s.hasNext() &&(contenuPrasing)){
				 while(s.hasNext()&& !((line.indexOf("\\begin{schema}"))>(-1))){
					 line = s.nextLine();
			     }
				 OperationName=line;
				 line = s.nextLine();
				 while(s.hasNext()&& !((line.indexOf("\\begin{schema}"))>(-1)) &&(!(line.equals("\\where")))&&(contenuPrasing)) {
					 boolean existRelation=line.indexOf("\\rel")>(-1);
					 if((existRelation)){
						 OperationName=OperationName.substring(15,OperationName.length()-1);
						 contenuPrasing=false;
					 }
					 line = s.nextLine();
				 }			 	
			 }			  
		}catch(Exception e){System.out.println("Exception"+e);}
		return OperationName;
	}
	
	/**
	 * Vrifie si le composamt en parametre est represent sous forme de schma Z.
	 * @param comp
	 * @return
	 */
	boolean isSchema(String comp){
		boolean exist =false;
		try{
			Scanner s = new Scanner(new FileReader(new File(Name)));
			String line="";
			 while(s.hasNext()){
				 if(line.equals("\\begin{schema}{"+comp+"}"))
					 exist=true;
				 line = s.nextLine();
			 }
		  }catch(Exception e){}
		return exist;
	}
	
	
	/**
	 * 
	 * @param args
	 */
	public static void main(String args[]){
		ParsingZ pz = new ParsingZ("CASlim.tex");
		System.out.println("  "+pz.getStyleSchemaName());
		//pz.getOperationName(pz.getStyleSchemaName());	
	}
}
