package CompileZ;

/** 
 * Transllate the Z opeartors to JAVA code. 
 * @author  Slim KALLEL
 * @version 1.0 20-11-06
 */
class TranslatePredicates{ //traduire les constraintes avec (and, or, implic,..) sous forme de mthodes.
	
	String s="";int i =0;
	String [] TabPredicat = new String [100];
	String [] TabOperator = new String [50];
	int [][] TabIndice = new int [100][3];
	
	String pred="a \\notin  ReviewerSection";
	int tailleP =0, tailleO=0;
	
	String Zfile;
	String Styleschema;
	boolean nothing=false;
	
	TranslatePredicates(String Zf,String Stylesc)
	{
		Zfile=Zf;
		Styleschema=Stylesc;		
	}
	
	

	public static void main(String args[])
	{
//		Predicate p = new Predicate();
	}
	
	public void Eval(String predicat){
		
		int and = predicat.indexOf("\\land");
		int or = predicat.indexOf("\\lor");
		int imp = predicat.indexOf("\\implies");
		int eq = predicat.indexOf("\\iff");
		if(and>0){
					

			String s1=predicat.substring(0,and-1);
			String s2=predicat.substring(and+6+1,predicat.length());
			
			TabPredicat[(2*i)+1]=s1;
			TabPredicat[((2*i)+1)+1]=s2;
			TabOperator[i]="\\land";
			i++;
			Eval(s1);			
			Eval(s2);	
		}
		else if(or>0){
				

			String s1=predicat.substring(0,or-1);
			String s2=predicat.substring(or+5+1,predicat.length());
				
			TabPredicat[(2*i)+1]=s1;
			TabPredicat[((2*i)+1)+1]=s2;
			TabOperator[i]="\\lor";
			i++;
			Eval(s1);	
			Eval(s2);	
		}
		else if(imp>0){
		

			String s1=predicat.substring(0,imp-1);
			String s2=predicat.substring(imp+9+1,predicat.length());
			TabPredicat[(2*i)+1]=s1;
			TabPredicat[((2*i)+1)+1]=s2;
			TabOperator[i]="\\implies";
			i++;
			Eval(s1);
			Eval(s2);	
		}
		else if(eq>0){
			String s1=predicat.substring(0,eq-1);
			String s2=predicat.substring(eq+5+1,predicat.length());
			TabPredicat[(2*i)+1]=s1;
			TabPredicat[((2*i)+1)+1]=s2;
			TabOperator[i]="\\iff";
			i++;
			Eval(s1);
			Eval(s2);		
		}
		else{
			
		}
		
		
		
	}
	
	public boolean have (String s){		
		boolean and1= s.indexOf("\\land")>0;		
		boolean Or1 = s.indexOf("\\lor")>0;	
		boolean Imp1 = s.indexOf("\\implies")>0;	
		boolean Eq1 = s.indexOf("\\iff")>0;
		return and1 || Or1 || Imp1 || Eq1;
	}
	
	
public String traduction(String s1,String s2, String op)
	{
		
		if(op.equals("\\land"))
			return "ZOpeartors.isAnd("+s1+","+s2+")";
		else if(op.equals("\\lor"))
			return "ZOpeartors.isOr("+s1+","+s2+")";
		else if(op.equals("\\implies"))
			return "ZOpeartors.isImplication("+s1+","+s2+")";
		else if(op.equals("\\iff"))
			return "ZOpeartors.isEquivalence("+s1+","+s2+")";
		else
			return null;
		
	}
	


	public void integration(){
		
		TranslateOperators trslt = new TranslateOperators(Zfile,Styleschema);
		for(int b=0;b<tailleP;b++){
		if(!have(TabPredicat[b])){
				TabPredicat[b]=trslt.recu(TabPredicat[b]);
				nothing=true;
			}
			trslt.NorO="New";
		}
	}


	public String constraint(String predicat)	
	{
		Eval(predicat);
		tailleP= (2*i)+1;
		tailleO= i;

		String c1="",c2="" ;
		int k=tailleO-1;
		String[] T = new String [tailleP];
		TabPredicat[0]=predicat;
		integration();
		for(int g=0;g<tailleP;g++){
			T[g]= TabPredicat[g];
		}
		String lastConst="";		
		String s1="",s2="";
		for(int j=tailleP-1;j>0;j=j-2){
			c1=TabPredicat[j-1]+" "+TabOperator[k]+" "+TabPredicat[j];
			
			if(have(TabPredicat[j])){
				s1=T[j];
			}
			else{
				s1=TabPredicat[j];
			}
			if(have(TabPredicat[j-1])){
				s2=T[j-1];
			}
			else
			{
				s2=TabPredicat[j-1];
			}
			String op= TabOperator[k];
			c2=traduction(s2,s1,op);
			
			for(int r=j;r>0;r--){

				if((TabPredicat[r].trim()).equals((c1.trim()))){
					T[r]=c2;
				}
			} 	
			k--;
		}
		if(T.length>1){
		
			if(!T[1].equals("") && !T[2].equals("")){
				
				String op= TabOperator[0];
				if(op.equals("\\land")) op = "ZOpeartors.isAnd";
				else if(op.equals("\\lor")) op = "ZOpeartors.isOr";
				else if(op.equals("\\implies"))op = "ZOpeartors.isImplication";
				else if(op.equals("\\iff")) op = "ZOpeartors.isEquivalence";
				else op="error";
				lastConst=op+"("+T[1]+","+T[2]+")";			
			} 
		}
		else{
			lastConst=T[0];
			
		}		
		return lastConst;
	}
}